﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Orgil;

namespace Polygon {
    public enum PolyPack {
        PolygonAdventure, PolygonApocalypse, PolygonBattleRoyale, PolygonBossZombies, PolygonCity, POLYGONCityCharacters, PolygonConstruction, PolygonDungeon,
        PolygonDungeonMap, PolygonExplorers, PolygonFantasyCharacters, PolygonFantasyHeroCharacters, PolygonFantasyKingdom, PolygonFantasyRivals, PolygonFarm,
        PolygonGangWarfare, PolygonHeist, POLYGONHorse, PolygonKnights, PolygonMilitary, PolygonNature, PolygonOffice, PolygonParticles, PolygonPirates,
        PolygonPrototype, PolygonSamurai, PolygonSciFiCity, PolygonSciFiSpace, PolygonSnow, PolygonSpy, PolygonStarter, PolygonTown, PolygonVikings, PolygonWar,
        PolygonWarMap, PolygonWestern, PolygonWesternFrontier, PolygonZombies,
    }
    public enum PolyBodyPart { Null, None, Root, Hips, Spine_01, Spine_02, Spine_03, Clavicle_L, Shoulder_L, Elbow_L, Hand_L, Clavicle_R, Shoulder_R, Elbow_R, Hand_R, Neck, Head, UpperLeg_L, LowerLeg_L, Ankle_L, Ball_L, Toes_L, UpperLeg_R, LowerLeg_R, Ankle_R, Ball_R, Toes_R }
    public class PolyName {
        public PolyPack pack;
        public string name;
        public PolyName(PolyPack pack, string name) { this.pack = pack; this.name = name; }
        public static PolyName Crt(object obj) {
            string[] arr = obj.tS().Split0("_");
            return new PolyName(arr[0].Enum<PolyPack>(), Poly.ReplaceName(arr[1]));
        }
    }
    public class PolyDataPath {
        public string pf = "Prefabs";
        public List<string> chrs = null, chrAtcs = null, weps = null, wepAtcs = null, vehs = null, vehAtcs = null, blds = null, envs = null, itms = null, prps = null, fxs = null;
        public PolyDataPath() { }
        public static PolyDataPath Pf(string pf) { PolyDataPath a = new PolyDataPath(); a.pf = pf; return a; }
        public static PolyDataPath Chrs(params string[] chrs) { PolyDataPath a = new PolyDataPath(); a.chrs = chrs.List(); return a; }
        public static PolyDataPath ChrAtcs(params string[] chrAtcs) { PolyDataPath a = new PolyDataPath(); a.chrAtcs = chrAtcs.List(); return a; }
        public static PolyDataPath Weps(params string[] weps) { PolyDataPath a = new PolyDataPath(); a.weps = weps.List(); return a; }
        public static PolyDataPath WepAtcs(params string[] wepAtcs) { PolyDataPath a = new PolyDataPath(); a.wepAtcs = wepAtcs.List(); return a; }
        public static PolyDataPath Vehs(params string[] vehs) { PolyDataPath a = new PolyDataPath(); a.vehs = vehs.List(); return a; }
        public static PolyDataPath VehAtcs(params string[] vehAtcs) { PolyDataPath a = new PolyDataPath(); a.vehAtcs = vehAtcs.List(); return a; }
        public static PolyDataPath Blds(params string[] blds) { PolyDataPath a = new PolyDataPath(); a.blds = blds.List(); return a; }
        public static PolyDataPath Envs(params string[] envs) { PolyDataPath a = new PolyDataPath(); a.envs = envs.List(); return a; }
        public static PolyDataPath Itms(params string[] itms) { PolyDataPath a = new PolyDataPath(); a.itms = itms.List(); return a; }
        public static PolyDataPath Prps(params string[] prps) { PolyDataPath a = new PolyDataPath(); a.prps = prps.List(); return a; }
        public static PolyDataPath Fxs(params string[] fxs) { PolyDataPath a = new PolyDataPath(); a.fxs = fxs.List(); return a; }
        public PolyDataPath Chr(params string[] chrs) { this.chrs = chrs.List(); return this; }
        public PolyDataPath ChrAtc(params string[] chrAtcs) { this.chrAtcs = chrAtcs.List(); return this; }
        public PolyDataPath Wep(params string[] weps) { this.weps = weps.List(); return this; }
        public PolyDataPath WepAtc(params string[] wepAtcs) { this.wepAtcs = wepAtcs.List(); return this; }
        public PolyDataPath Veh(params string[] vehs) { this.vehs = vehs.List(); return this; }
        public PolyDataPath VehAtc(params string[] vehAtcs) { this.vehAtcs = vehAtcs.List(); return this; }
        public PolyDataPath Bld(params string[] blds) { this.blds = blds.List(); return this; }
        public PolyDataPath Env(params string[] envs) { this.envs = envs.List(); return this; }
        public PolyDataPath Itm(params string[] itms) { this.itms = itms.List(); return this; }
        public PolyDataPath Prp(params string[] prps) { this.prps = prps.List(); return this; }
        public PolyDataPath Fx(params string[] fxs) { this.fxs = fxs.List(); return this; }
    }
    public class PolyChrData {
        public float s = 1;
        public PolyChrData C => new PolyChrData(this);
        public PolyChrData() { }
        public PolyChrData(PolyChrData data) {
        }
        public PolyChrData S(float s) { this.s = s; return this; }
    }
    public enum PolyChr {
        PolygonAdventure_Character_Knight_Black, PolygonAdventure_Character_Knight_Brown, PolygonAdventure_Character_Knight_White, PolygonAdventure_Character_Peasant_Black, PolygonAdventure_Character_Peasant_Brown, PolygonAdventure_Character_Peasant_White, PolygonAdventure_Character_Shopkeeper_Black, PolygonAdventure_Character_Shopkeeper_Brown, PolygonAdventure_Character_Shopkeeper_White, PolygonAdventure_Character_Viking_Black, PolygonAdventure_Character_Viking_Brown, PolygonAdventure_Character_Viking_White, PolygonAdventure_Character_Warrior_Black, PolygonAdventure_Character_Warrior_Brown, PolygonAdventure_Character_Warrior_White,
        PolygonApocalypse_SM_Chr_Biker_Male_01, PolygonApocalypse_SM_Chr_Business_Male_01, PolygonApocalypse_SM_Chr_Cool_Female_01, PolygonApocalypse_SM_Chr_Cool_Male_01, PolygonApocalypse_SM_Chr_Criminal_Male_01, PolygonApocalypse_SM_Chr_Eastern_Female_01, PolygonApocalypse_SM_Chr_Emo_Female_01, PolygonApocalypse_SM_Chr_Hazmat_Male_01, PolygonApocalypse_SM_Chr_Homeless_Male_01, PolygonApocalypse_SM_Chr_Hunter_Male_01, PolygonApocalypse_SM_Chr_Islander_Male_01, PolygonApocalypse_SM_Chr_Mechanic_Female_01, PolygonApocalypse_SM_Chr_Nerd_Female_01, PolygonApocalypse_SM_Chr_Nun_Female_01, PolygonApocalypse_SM_Chr_Patient_Female_01, PolygonApocalypse_SM_Chr_Press_Male_01, PolygonApocalypse_SM_Chr_Punk_Female_01, PolygonApocalypse_SM_Chr_RiotCop_Male_01, PolygonApocalypse_SM_Chr_Scout_Female_01, PolygonApocalypse_SM_Chr_Sheriff_Male_01, PolygonApocalypse_SM_Chr_Soldier_Female_01, PolygonApocalypse_SM_Chr_Soldier_Male_01, PolygonApocalypse_SM_Chr_Teen_Female_01, PolygonApocalypse_SM_Chr_Teen_Male_01, PolygonApocalypse_SM_Chr_Waitress_Female_01, PolygonApocalypse_SM_Chr_Wanderer_Male_01, PolygonApocalypse_SM_Chr_Zombie_Female_01, PolygonApocalypse_SM_Chr_Zombie_Female_02, PolygonApocalypse_SM_Chr_Zombie_Male_01, PolygonApocalypse_SM_Chr_Zombie_Male_02,
        PolygonBattleRoyale_Character_70sFemale_01, PolygonBattleRoyale_Character_BusinessMale_01, PolygonBattleRoyale_Character_GhillieSuit_01, PolygonBattleRoyale_Character_GothFemale_01, PolygonBattleRoyale_Character_MercenaryFemale_01, PolygonBattleRoyale_Character_MercenaryMale_01, PolygonBattleRoyale_Character_MilitaryFemale_01, PolygonBattleRoyale_Character_MilitaryMale_01, PolygonBattleRoyale_Character_RedneckMale_01, PolygonBattleRoyale_Character_SportsBraFemale_01, PolygonBattleRoyale_Character_SportyFemale_01, PolygonBattleRoyale_Character_SportyFemale_02, PolygonBattleRoyale_Character_SportyMale_01, PolygonBattleRoyale_Character_SportyMale_02, PolygonBattleRoyale_Character_ToplessMale_01,
        PolygonBossZombies_SM_Chr_ZombieBoss_Blobber_01, PolygonBossZombies_SM_Chr_ZombieBoss_Brute_01, PolygonBossZombies_SM_Chr_ZombieBoss_Slobber_01, PolygonBossZombies_SM_Chr_ZombieBoss_Wretch_01,
        PolygonCity_Character_BusinessMan_Shirt_01, PolygonCity_Character_BusinessMan_Suit_01, PolygonCity_Character_BusinessWoman_01, PolygonCity_Character_Female_Coat_01, PolygonCity_Character_Female_Jacket_01, PolygonCity_Character_Female_Police_01, PolygonCity_Character_Male_Hoodie_01, PolygonCity_Character_Male_Jacket_01, PolygonCity_Character_Male_Police_01,
        POLYGONCityCharacters_Character_Biker_01, POLYGONCityCharacters_Character_FastFoodGuy_01, POLYGONCityCharacters_Character_FireFighter_01, POLYGONCityCharacters_Character_GamerGirl_01, POLYGONCityCharacters_Character_Gangster_01, POLYGONCityCharacters_Character_Grandma_01, POLYGONCityCharacters_Character_Grandpa_01, POLYGONCityCharacters_Character_HipsterGirl_01, POLYGONCityCharacters_Character_HipsterGuy_01, POLYGONCityCharacters_Character_Hobo_01, POLYGONCityCharacters_Character_Hotdog_01, POLYGONCityCharacters_Character_Jock_01, POLYGONCityCharacters_Character_Paramedic_01, POLYGONCityCharacters_Character_PunkGirl_01, POLYGONCityCharacters_Character_PunkGuy_01, POLYGONCityCharacters_Character_Roadworker_01, POLYGONCityCharacters_Character_ShopKeeper_01, POLYGONCityCharacters_Character_SummerGirl_01, POLYGONCityCharacters_Character_Tourist_01,
        PolygonConstruction_SM_Chr_Builder_Female_01, PolygonConstruction_SM_Chr_Builder_Harness_01, PolygonConstruction_SM_Chr_Builder_HighVis_01, PolygonConstruction_SM_Chr_Builder_Male_01, PolygonConstruction_SM_Chr_Builder_Overalls_01, PolygonConstruction_SM_Chr_Builder_Raincoat_01, PolygonConstruction_SM_Chr_Builder_Singlet_01, PolygonConstruction_SM_Chr_Inspector_Female_01, PolygonConstruction_SM_Chr_Inspector_Male_01,
        PolygonDungeon_Character_Ghost_01, PolygonDungeon_Character_Ghost_02, PolygonDungeon_Character_Goblin_Female, PolygonDungeon_Character_Goblin_Male, PolygonDungeon_Character_Goblin_Shaman, PolygonDungeon_Character_Goblin_WarChief, PolygonDungeon_Character_Goblin_Warrior_Female, PolygonDungeon_Character_Goblin_Warrior_Male, PolygonDungeon_Character_Hero_Knight_Female, PolygonDungeon_Character_Hero_Knight_Male, PolygonDungeon_Character_Rock_Golem, PolygonDungeon_Character_Skeleton_Knight, PolygonDungeon_Character_Skeleton_Slave_01, PolygonDungeon_Character_Skeleton_Soldier_01, PolygonDungeon_Character_Skeleton_Soldier_02, PolygonDungeon_Character_Tormented_Soul,
        PolygonExplorers_Character_Explorer_Female_01, PolygonExplorers_Character_Explorer_Male_01,
        PolygonFantasyCharacters_Character_Female_Druid_01, PolygonFantasyCharacters_Character_Female_Gypsy_01, PolygonFantasyCharacters_Character_Female_Peasant_01, PolygonFantasyCharacters_Character_Female_Peasant_02, PolygonFantasyCharacters_Character_Female_Queen_01, PolygonFantasyCharacters_Character_Female_Witch_01, PolygonFantasyCharacters_Character_Male_Baird_01, PolygonFantasyCharacters_Character_Male_King_01, PolygonFantasyCharacters_Character_Male_Peasant_01, PolygonFantasyCharacters_Character_Male_Rouge_01, PolygonFantasyCharacters_Character_Male_Sorcerer_01, PolygonFantasyCharacters_Character_Male_Wizard_01,
        PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_1, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_2, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_3, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_4, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_5, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_6, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_7, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_8, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_9, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_10, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_11, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_12, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_13, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_14, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_15, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_16, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_17, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_18, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_19, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_20, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_21, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_22, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_23, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_24, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_25, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_26, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_27, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_28, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_29, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_30, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_31, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_32, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_33, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_34, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_35, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_36, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_37, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_38, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_39, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_40, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_41, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_42, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_43, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_44, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_45, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_46, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_47, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_48, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_49, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_50, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_51, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_52, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_53, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_54, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_55, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_56, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_57, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_58, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_59, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_60, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_61, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_62, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_63, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_64, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_65, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_66, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_67, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_68, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_69, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_70, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_71, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_72, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_73, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_74, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_75, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_76, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_77, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_78, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_79, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_80, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_81, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_82, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_83, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_84, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_85, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_86, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_87, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_88, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_89, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_90, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_91, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_92, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_93, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_94, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_95, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_96, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_97, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_98, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_99, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_100, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_101, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_102, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_103, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_104, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_105, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_106, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_107, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_108, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_109, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_110, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_111, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_112, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_113, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_114, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_115, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_116, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_117, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_118, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_119, PolygonFantasyHeroCharacters_Chr_FantasyHero_Preset_120,
        PolygonFantasyKingdom_SM_Chr_Bartender_01, PolygonFantasyKingdom_SM_Chr_Blacksmith_Female_01, PolygonFantasyKingdom_SM_Chr_Blacksmith_Male_01, PolygonFantasyKingdom_SM_Chr_Fairy_01, PolygonFantasyKingdom_SM_Chr_FortuneTeller_01, PolygonFantasyKingdom_SM_Chr_Headsman_01, PolygonFantasyKingdom_SM_Chr_Hermit_01, PolygonFantasyKingdom_SM_Chr_Jester_01, PolygonFantasyKingdom_SM_Chr_King_01, PolygonFantasyKingdom_SM_Chr_Mage_01, PolygonFantasyKingdom_SM_Chr_Merchant_01, PolygonFantasyKingdom_SM_Chr_Monk_01, PolygonFantasyKingdom_SM_Chr_Nun_01, PolygonFantasyKingdom_SM_Chr_Peasant_Female_01, PolygonFantasyKingdom_SM_Chr_Peasant_Male_01, PolygonFantasyKingdom_SM_Chr_Priest_01, PolygonFantasyKingdom_SM_Chr_Princess_01, PolygonFantasyKingdom_SM_Chr_Prince_01, PolygonFantasyKingdom_SM_Chr_Queen_01, PolygonFantasyKingdom_SM_Chr_Rider_01, PolygonFantasyKingdom_SM_Chr_Soldier_Female_01, PolygonFantasyKingdom_SM_Chr_Soldier_Male_01,
        PolygonFantasyRivals_Character_AncientQueen_01, PolygonFantasyRivals_Character_AncientWarrior_01, PolygonFantasyRivals_Character_BR_BarbarianGiant_01, PolygonFantasyRivals_Character_BR_BigOrk_01, PolygonFantasyRivals_Character_BR_Dwarf_01, PolygonFantasyRivals_Character_BR_ElementalGolem_01, PolygonFantasyRivals_Character_BR_FortGolem_01, PolygonFantasyRivals_Character_BR_MechanicalGolem_01, PolygonFantasyRivals_Character_BR_MutantGuy_01, PolygonFantasyRivals_Character_BR_PigButcher_01, PolygonFantasyRivals_Character_BR_RedDemon_01, PolygonFantasyRivals_Character_BR_Slayer_01, PolygonFantasyRivals_Character_BR_Troll_01, PolygonFantasyRivals_Character_DarkElf_01, PolygonFantasyRivals_Character_EvilGod_01, PolygonFantasyRivals_Character_ForestGuardian_01, PolygonFantasyRivals_Character_ForestWitch_01, PolygonFantasyRivals_Character_Medusa_01, PolygonFantasyRivals_Character_Mystic_01, PolygonFantasyRivals_Character_SpiritDemon_01,
        PolygonFarm_SM_Chr_FarmBoy_01, PolygonFarm_SM_Chr_Farmer_Female_01, PolygonFarm_SM_Chr_Farmer_Male_01, PolygonFarm_SM_Chr_Farmer_Male_Old_01, PolygonFarm_SM_Chr_FarmGirl_01, PolygonFarm_SM_Chr_Scarecrow_01,
        PolygonGangWarfare_SM_Chr_Asian_Gangster_Male_01, PolygonGangWarfare_SM_Chr_British_Gangster_Male_01, PolygonGangWarfare_SM_Chr_Cook_Female_01, PolygonGangWarfare_SM_Chr_Cook_Male_01, PolygonGangWarfare_SM_Chr_DEA_Agent_Female_01, PolygonGangWarfare_SM_Chr_DEA_Agent_Male_01, PolygonGangWarfare_SM_Chr_DEA_Plainclothes_Male_01, PolygonGangWarfare_SM_Chr_GangBoss_01, PolygonGangWarfare_SM_Chr_GangMember_Female_01, PolygonGangWarfare_SM_Chr_GangMember_Male_01, PolygonGangWarfare_SM_Chr_GangMember_Male_02, PolygonGangWarfare_SM_Chr_GangMember_Male_03, PolygonGangWarfare_SM_Chr_Hazmat_Suit_Male_01, PolygonGangWarfare_SM_Chr_Italian_Gangster_01, PolygonGangWarfare_SM_Chr_StreetGirl_01, PolygonGangWarfare_SM_Chr_Underwear_Female_01, PolygonGangWarfare_SM_Chr_Underwear_Male_01,
        PolygonHeist_Character_Female_FBI_01, PolygonHeist_Character_Female_Overall_01, PolygonHeist_Character_Female_Shirt_01, PolygonHeist_Character_Female_SuitVest_01, PolygonHeist_Character_Male_FBI, PolygonHeist_Character_Male_Overall_01, PolygonHeist_Character_Male_Shirt_01, PolygonHeist_Character_Male_SuitVest_01, PolygonHeist_Character_Male_SWAT_01,
        PolygonKnights_Character_Knight_01_Black, PolygonKnights_Character_Knight_01_Blue, PolygonKnights_Character_Knight_01_Orange, PolygonKnights_Character_Knight_01_Yellow, PolygonKnights_Character_Knight_02_Black, PolygonKnights_Character_Knight_02_Blue, PolygonKnights_Character_Knight_02_Orange, PolygonKnights_Character_Knight_02_Yellow, PolygonKnights_Character_Knight_03_Black, PolygonKnights_Character_Knight_03_Blue, PolygonKnights_Character_Knight_03_Orange, PolygonKnights_Character_Knight_03_Yellow, PolygonKnights_Character_Soldier_01_Black, PolygonKnights_Character_Soldier_01_Blue, PolygonKnights_Character_Soldier_01_Orange, PolygonKnights_Character_Soldier_01_Yellow, PolygonKnights_Character_Soldier_02_Black, PolygonKnights_Character_Soldier_02_Blue, PolygonKnights_Character_Soldier_02_Orange, PolygonKnights_Character_Soldier_02_Yellow,
        PolygonMilitary_SM_Chr_Soldier_Female_01_Alt_01, PolygonMilitary_SM_Chr_Soldier_Female_01_Alt_02, PolygonMilitary_SM_Chr_Soldier_Female_02_Alt_01, PolygonMilitary_SM_Chr_Soldier_Female_02_Alt_02, PolygonMilitary_SM_Chr_Soldier_Male_01_Alt_01, PolygonMilitary_SM_Chr_Soldier_Male_01_Alt_02, PolygonMilitary_SM_Chr_Soldier_Male_02_Alt_01, PolygonMilitary_SM_Chr_Soldier_Male_02_Alt_02, PolygonMilitary_SM_Chr_Soldier_Male_02_Alt_03, PolygonMilitary_SM_Chr_Soldier_Male_02_Alt_04, PolygonMilitary_SM_Chr_Bombsuit_Male_01, PolygonMilitary_SM_Chr_Civilian_Female_01, PolygonMilitary_SM_Chr_Civilian_Female_02, PolygonMilitary_SM_Chr_Civilian_Male_01, PolygonMilitary_SM_Chr_Civilian_Male_02, PolygonMilitary_SM_Chr_Contractor_Female_01, PolygonMilitary_SM_Chr_Contractor_Male_01, PolygonMilitary_SM_Chr_Contractor_Male_02, PolygonMilitary_SM_Chr_Ghillie_Male_01, PolygonMilitary_SM_Chr_Insurgent_Female_01, PolygonMilitary_SM_Chr_Insurgent_Female_02, PolygonMilitary_SM_Chr_Insurgent_Male_01, PolygonMilitary_SM_Chr_Insurgent_Male_02, PolygonMilitary_SM_Chr_Insurgent_Male_03, PolygonMilitary_SM_Chr_Insurgent_Male_04, PolygonMilitary_SM_Chr_Insurgent_Male_05, PolygonMilitary_SM_Chr_Leader_Male_01, PolygonMilitary_SM_Chr_Pilot_Female_01, PolygonMilitary_SM_Chr_Pilot_Male_01, PolygonMilitary_SM_Chr_Soldier_Female_01, PolygonMilitary_SM_Chr_Soldier_Female_02, PolygonMilitary_SM_Chr_Soldier_Male_01, PolygonMilitary_SM_Chr_Soldier_Male_02,
        PolygonOffice_SM_Chr_Boss_Female_01, PolygonOffice_SM_Chr_Boss_Male_01, PolygonOffice_SM_Chr_Business_Female_01, PolygonOffice_SM_Chr_Business_Female_02, PolygonOffice_SM_Chr_Business_Female_03, PolygonOffice_SM_Chr_Business_Female_04, PolygonOffice_SM_Chr_Business_Male_01, PolygonOffice_SM_Chr_Business_Male_02, PolygonOffice_SM_Chr_Business_Male_03, PolygonOffice_SM_Chr_Business_Male_04, PolygonOffice_SM_Chr_Cleaner_Female_01, PolygonOffice_SM_Chr_Cleaner_Male_01, PolygonOffice_SM_Chr_Developer_Female_01, PolygonOffice_SM_Chr_Developer_Female_02, PolygonOffice_SM_Chr_Developer_Male_01, PolygonOffice_SM_Chr_Developer_Male_02, PolygonOffice_SM_Chr_Security_Female_01, PolygonOffice_SM_Chr_Security_Male_01,
        PolygonPirates_Character_English_Captain_01, PolygonPirates_Character_English_Govenor_01, PolygonPirates_Character_English_Soldier_01, PolygonPirates_Character_Female_Pirate_01, PolygonPirates_Character_Female_Wench_01, PolygonPirates_Character_Gentleman_01, PolygonPirates_Character_Governors_Daughter_01, PolygonPirates_Character_Pirate_Blackbeard_01, PolygonPirates_Character_Pirate_Captain_01, PolygonPirates_Character_Pirate_Deckhand_01, PolygonPirates_Character_Pirate_First_Mate_01, PolygonPirates_Character_Pirate_Seaman_01, PolygonPirates_Character_Skeleton_01, PolygonPirates_Character_Skeleton_02, PolygonPirates_Character_Skeleton_03,
        PolygonPrototype_Character_Dummy_Female_01, PolygonPrototype_Character_Dummy_Male_01, PolygonPrototype_Character_Female_Face_01, PolygonPrototype_Character_Female_NoFace_01, PolygonPrototype_Character_Male_Face_01, PolygonPrototype_Character_Male_NoFace_01,
        PolygonSamurai_Character_Geisha_Black, PolygonSamurai_Character_Geisha_Brown, PolygonSamurai_Character_Geisha_White, PolygonSamurai_Character_Ninja_Black, PolygonSamurai_Character_Ninja_Brown, PolygonSamurai_Character_Ninja_White, PolygonSamurai_Character_Samurai_Grunt_Black, PolygonSamurai_Character_Samurai_Grunt_Brown, PolygonSamurai_Character_Samurai_Grunt_White, PolygonSamurai_Character_Samurai_Warrior_Black, PolygonSamurai_Character_Samurai_Warrior_Brown, PolygonSamurai_Character_Samurai_Warrior_White, PolygonSamurai_Character_Sensei_Black, PolygonSamurai_Character_Sensei_Brown, PolygonSamurai_Character_Sensei_White, PolygonSamurai_Character_Village_Man_Black, PolygonSamurai_Character_Village_Man_Brown, PolygonSamurai_Character_Village_Man_White, PolygonSamurai_Character_Village_Woman_Black, PolygonSamurai_Character_Village_Woman_Brown, PolygonSamurai_Character_Village_Woman_White,
        PolygonSciFiCity_Character_Alien_Male_01, PolygonSciFiCity_Character_Alien_Male_02, PolygonSciFiCity_Character_Android_Female_01, PolygonSciFiCity_Character_Augmented_Male_01, PolygonSciFiCity_Character_Cop_01, PolygonSciFiCity_Character_CyberPunk_Male_01, PolygonSciFiCity_Character_Cyber_Female_01, PolygonSciFiCity_Character_Cyber_Male_01, PolygonSciFiCity_Character_CyborgNinja_01, PolygonSciFiCity_Character_Garbage_Male_01, PolygonSciFiCity_Character_Hacker_Female_01, PolygonSciFiCity_Character_Hologram_Female_01, PolygonSciFiCity_Character_Junky_Female_01, PolygonSciFiCity_Character_Junky_Male_01, PolygonSciFiCity_Character_Medical_Male_01, PolygonSciFiCity_Character_Monk_Male_01, PolygonSciFiCity_Character_Muscle_Male_01, PolygonSciFiCity_Character_Rich_Female_01, PolygonSciFiCity_Character_Rich_Male_01, PolygonSciFiCity_Character_Robot_01,
        PolygonSciFiSpace_SM_Chr_Alien_01, PolygonSciFiSpace_SM_Chr_BR_BigAlien_01, PolygonSciFiSpace_SM_Chr_BR_BigAlien_02, PolygonSciFiSpace_SM_Chr_BR_EVA_Suit_01, PolygonSciFiSpace_SM_Chr_BR_SpaceSoldier_Male_01, PolygonSciFiSpace_SM_Chr_BR_War_Robot_01, PolygonSciFiSpace_SM_Chr_CrewCaptain_Female_01, PolygonSciFiSpace_SM_Chr_CrewCaptain_Male_01, PolygonSciFiSpace_SM_Chr_Crew_Female_01, PolygonSciFiSpace_SM_Chr_Crew_Male_01, PolygonSciFiSpace_SM_Chr_Cryo_Female_01, PolygonSciFiSpace_SM_Chr_Cryo_Male_01, PolygonSciFiSpace_SM_Chr_Hunter_Female_01, PolygonSciFiSpace_SM_Chr_Junker_Female_01, PolygonSciFiSpace_SM_Chr_Junker_Male_01, PolygonSciFiSpace_SM_Chr_Medic_Male_01, PolygonSciFiSpace_SM_Chr_Psionic_01, PolygonSciFiSpace_SM_Chr_RobotFemale_01, PolygonSciFiSpace_SM_Chr_SpaceSoldier_Female_01, PolygonSciFiSpace_SM_Chr_SpaceSoldier_HelmetArmor_Female_01, PolygonSciFiSpace_SM_Chr_SpaceSoldier_HelmetArmor_Male_01, PolygonSciFiSpace_SM_Chr_SpaceSoldier_Helmet_Female_01, PolygonSciFiSpace_SM_Chr_SpaceSoldier_Helmet_Male_01, PolygonSciFiSpace_SM_Chr_SpaceSoldier_Male_01,
        PolygonSnow_Character_Skier_01, PolygonSnow_Character_Snowboarder_01,
        PolygonSpy_Chr_Female_Spy, PolygonSpy_Chr_Male_Spy_Bowtie, PolygonSpy_Chr_Male_Spy_Necktie,
        PolygonStarter_SM_Character_Female_01, PolygonStarter_SM_Character_Male_01,
        PolygonTown_Character_Daughter_01, PolygonTown_Character_Father_01, PolygonTown_Character_Father_02, PolygonTown_Character_Mother_01, PolygonTown_Character_Mother_02, PolygonTown_Character_SchoolBoy_01, PolygonTown_Character_SchoolGirl_01, PolygonTown_Character_ShopKeeper_01, PolygonTown_Character_Son_01,
        PolygonVikings_Character_Chief_01_Black, PolygonVikings_Character_Chief_01_Brown, PolygonVikings_Character_Chief_01_White, PolygonVikings_Character_Grunt_01_Black, PolygonVikings_Character_Grunt_01_Brown, PolygonVikings_Character_Grunt_01_White, PolygonVikings_Character_Grunt_02_Black, PolygonVikings_Character_Grunt_02_Brown, PolygonVikings_Character_Grunt_02_White, PolygonVikings_Character_Shieldmadien_Black, PolygonVikings_Character_Shieldmadien_Brown, PolygonVikings_Character_Shieldmadien_White, PolygonVikings_Character_Warrior_01_Black, PolygonVikings_Character_Warrior_01_Brown, PolygonVikings_Character_Warrior_01_White, PolygonVikings_Character_Warrior_02_Black, PolygonVikings_Character_Warrior_02_Brown, PolygonVikings_Character_Warrior_02_White,
        PolygonWar_Character_AmericanOfficer_Female_01, PolygonWar_Character_AmericanOfficer_Male_01, PolygonWar_Character_American_Soldier_01, PolygonWar_Character_American_Soldier_02, PolygonWar_Character_American_Soldier_Attachments_01, PolygonWar_Character_American_Soldier_Attachments_02, PolygonWar_Character_British_Leader_01, PolygonWar_Character_Commando_01, PolygonWar_Character_FactoryGirl_01, PolygonWar_Character_GentleMan_01, PolygonWar_Character_German_Leader_01, PolygonWar_Character_German_Officer_01, PolygonWar_Character_German_Officer_02, PolygonWar_Character_German_Soldier_01, PolygonWar_Character_German_Soldier_02, PolygonWar_Character_German_Soldier_Attachments_01, PolygonWar_Character_German_Soldier_Attachments_02, PolygonWar_Character_Nurse_Female_01, PolygonWar_Character_Old_Lady_01, PolygonWar_Character_Pilot_01, PolygonWar_Character_Resistance_Female_01, PolygonWar_Character_Resistance_Male_01, PolygonWar_Character_Russian_Leader_01, PolygonWar_Character_Russian_Soldier_01,
        PolygonWestern_Character_Badguy_01, PolygonWestern_Character_Business_Man_01, PolygonWestern_Character_Cowboy_01, PolygonWestern_Character_Cowgirl_01, PolygonWestern_Character_Gunman_01, PolygonWestern_Character_SaloonGirl_01, PolygonWestern_Character_Sheriff_01, PolygonWestern_Character_Woman_01,
        PolygonWesternFrontier_Character_Bandit_Male_01, PolygonWesternFrontier_Character_Captain_Male_01, PolygonWesternFrontier_Character_GoldMiner_Male_01, PolygonWesternFrontier_Character_GoldMiner_Male_02, PolygonWesternFrontier_Character_Hunter_Male_01, PolygonWesternFrontier_Character_Mexican_Female_01, PolygonWesternFrontier_Character_Mexican_Male_01, PolygonWesternFrontier_Character_Mexican_Male_02, PolygonWesternFrontier_Character_NativeAmericanChief_Male_01, PolygonWesternFrontier_Character_NativeAmericanElder_Female_01, PolygonWesternFrontier_Character_NativeAmericanWarrior_Female_01, PolygonWesternFrontier_Character_NativeAmericanWarrior_Male_01, PolygonWesternFrontier_Character_NativeAmericanWarrior_Male_02, PolygonWesternFrontier_Character_NativeAmericanWarrior_Male_03, PolygonWesternFrontier_Character_NativeAmerican_Female_01, PolygonWesternFrontier_Character_Priest_Male_01, PolygonWesternFrontier_Character_Salesman_Male_01, PolygonWesternFrontier_Character_Soldier_Male_01, PolygonWesternFrontier_Character_Thug_Male_01, PolygonWesternFrontier_Character_Thug_Male_02, PolygonWesternFrontier_Character_Traveler_Female_01,
        PolygonZombies_Zombie_Bellboy_Male_01, PolygonZombies_Zombie_Biker_Male_01, PolygonZombies_Zombie_BioHazardSuit_Male_01, PolygonZombies_Zombie_Bride_Female_01, PolygonZombies_Zombie_Businessman_Male_01, PolygonZombies_Zombie_BusinessShirt_Male_01, PolygonZombies_Zombie_Business_Female_01, PolygonZombies_Zombie_Cheerleader_Female_01, PolygonZombies_Zombie_Clown_Male_01, PolygonZombies_Zombie_Coat_Female_01, PolygonZombies_Zombie_Daughter_Female_01, PolygonZombies_Zombie_Diver_Male_01, PolygonZombies_Zombie_FastfoodWorker_Male_01, PolygonZombies_Zombie_Father_Male_01, PolygonZombies_Zombie_Father_Male_02, PolygonZombies_Zombie_Firefighter_Male_01, PolygonZombies_Zombie_Footballer_Male_01, PolygonZombies_Zombie_GamerGirl_Female_01, PolygonZombies_Zombie_Gangster_Male_01, PolygonZombies_Zombie_Grandma_Female_01, PolygonZombies_Zombie_Grandpa_Male_01, PolygonZombies_Zombie_Hipster_Female_01, PolygonZombies_Zombie_Hipster_Male_01, PolygonZombies_Zombie_Hobo_Male_01, PolygonZombies_Zombie_Hoodie_Male_01, PolygonZombies_Zombie_HotDogSuit_Male_01, PolygonZombies_Zombie_Jacket_Female_01, PolygonZombies_Zombie_Jacket_Male_01, PolygonZombies_Zombie_Jock_Male_01, PolygonZombies_Zombie_Military_Male_01, PolygonZombies_Zombie_Mother_Female_01, PolygonZombies_Zombie_Mother_Female_02, PolygonZombies_Zombie_Paramedic_Female_01, PolygonZombies_Zombie_Patient_Female_01, PolygonZombies_Zombie_Police_Female_01, PolygonZombies_Zombie_Police_Male_01, PolygonZombies_Zombie_Prisoner_Male_01, PolygonZombies_Zombie_Punk_Female_01, PolygonZombies_Zombie_Punk_Male_01, PolygonZombies_Zombie_RiotCop_Male_01, PolygonZombies_Zombie_Roadworker_Male_01, PolygonZombies_Zombie_SchoolBoy_Male_01, PolygonZombies_Zombie_SchoolGirl_Female_01, PolygonZombies_Zombie_ShopKeeper_Female_01, PolygonZombies_Zombie_ShopKeeper_Male_01, PolygonZombies_Zombie_Son_Male_01, PolygonZombies_Zombie_SummerGirl_Female_01, PolygonZombies_Zombie_Tourist_Male_01, PolygonZombies_Zombie_Underwear_Female_01, PolygonZombies_Zombie_Underwear_Male_01,
    }
    public partial class Poly : Mb {
        public static PolyChrData Pcd = new PolyChrData();
        public static Dictionary<PolyChr, PolyChrData> PolyChrDic = new Dictionary<PolyChr, PolyChrData>() {
            // PolygonBossZombies
            { PolyChr.PolygonBossZombies_SM_Chr_ZombieBoss_Blobber_01,      Pcd.C.S(1.5f) },
            { PolyChr.PolygonBossZombies_SM_Chr_ZombieBoss_Brute_01,        Pcd.C.S(2) },
            { PolyChr.PolygonBossZombies_SM_Chr_ZombieBoss_Slobber_01,      Pcd.C.S(1.5f) },
            { PolyChr.PolygonBossZombies_SM_Chr_ZombieBoss_Wretch_01,       Pcd.C.S(1.35f) },
            // PolygonFantasyKingdom
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Bartender_01,            Pcd.C.S(1.03f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Blacksmith_Female_01,    Pcd.C.S(0.95f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Blacksmith_Male_01,      Pcd.C.S(1.02f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Fairy_01,                Pcd.C.S(0.5f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_FortuneTeller_01,        Pcd.C.S(0.98f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Headsman_01,             Pcd.C.S(1.04f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Hermit_01,               Pcd.C.S(1) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Jester_01,               Pcd.C.S(0.98f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_King_01,                 Pcd.C.S(1.02f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Mage_01,                 Pcd.C.S(1) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Merchant_01,             Pcd.C.S(1.01f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Monk_01,                 Pcd.C.S(1) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Nun_01,                  Pcd.C.S(0.98f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Peasant_Female_01,       Pcd.C.S(0.98f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Peasant_Male_01,         Pcd.C.S(1) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Priest_01,               Pcd.C.S(1) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Princess_01,             Pcd.C.S(0.99f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Prince_01,               Pcd.C.S(1) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Queen_01,                Pcd.C.S(0.98f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Rider_01,                Pcd.C.S(1) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Soldier_Female_01,       Pcd.C.S(0.99f) },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Soldier_Male_01,         Pcd.C.S(1.02f) },
            // PolygonFantasyRivals
            { PolyChr.PolygonFantasyRivals_Character_AncientQueen_01,       Pcd.C.S(0.95f) },
            { PolyChr.PolygonFantasyRivals_Character_AncientWarrior_01,     Pcd.C.S(1.1f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_BarbarianGiant_01,  Pcd.C.S(2.2f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_BigOrk_01,          Pcd.C.S(1.2f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_Dwarf_01,           Pcd.C.S(0.75f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_ElementalGolem_01,  Pcd.C.S(2.5f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_FortGolem_01,       Pcd.C.S(3) },
            { PolyChr.PolygonFantasyRivals_Character_BR_MechanicalGolem_01, Pcd.C.S(2) },
            { PolyChr.PolygonFantasyRivals_Character_BR_MutantGuy_01,       Pcd.C.S(1.5f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_PigButcher_01,      Pcd.C.S(1.25f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_RedDemon_01,        Pcd.C.S(1.6f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_Slayer_01,          Pcd.C.S(1.4f) },
            { PolyChr.PolygonFantasyRivals_Character_BR_Troll_01,           Pcd.C.S(2) },
            { PolyChr.PolygonFantasyRivals_Character_DarkElf_01,            Pcd.C.S(1) },
            { PolyChr.PolygonFantasyRivals_Character_EvilGod_01,            Pcd.C.S(1.25f) },
            { PolyChr.PolygonFantasyRivals_Character_ForestGuardian_01,     Pcd.C.S(1.05f) },
            { PolyChr.PolygonFantasyRivals_Character_ForestWitch_01,        Pcd.C.S(0.9f) },
            { PolyChr.PolygonFantasyRivals_Character_Medusa_01,             Pcd.C.S(0.95f) },
            { PolyChr.PolygonFantasyRivals_Character_Mystic_01,             Pcd.C.S(1) },
            { PolyChr.PolygonFantasyRivals_Character_SpiritDemon_01,        Pcd.C.S(1) },
        };
        public static Dictionary<PolyBodyPart, List<string>> PartPathDic = new Dictionary<PolyBodyPart, List<string>>() {
            { PolyBodyPart.None,                        List("",                                                                            "") },
            { PolyBodyPart.Root,                        List("Root",                                                                        "root") },
            { PolyBodyPart.Hips,                        List("Root/Hips",                                                                   "root/pelvis") },
            { PolyBodyPart.Spine_01,                    List("Root/Hips/Spine_01",                                                          "root/pelvis/spine_01") },
            { PolyBodyPart.Spine_02,                    List("Root/Hips/Spine_01/Spine_02",                                                 "root/pelvis/spine_01/spine_02") },
            { PolyBodyPart.Spine_03,                    List("Root/Hips/Spine_01/Spine_02/Spine_03",                                        "root/pelvis/spine_01/spine_02/spine_03") },
            { PolyBodyPart.Clavicle_L,                  List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_L",                             "root/pelvis/spine_01/spine_02/spine_03/clavicle_l") },
            { PolyBodyPart.Shoulder_L,                  List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_L/Shoulder_L",                  "root/pelvis/spine_01/spine_02/spine_03/clavicle_l/upperarm_l") },
            { PolyBodyPart.Elbow_L,                     List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_L/Shoulder_L/Elbow_L",          "root/pelvis/spine_01/spine_02/spine_03/clavicle_l/upperarm_l/lowerarm_l") },
            { PolyBodyPart.Hand_L,                      List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_L/Shoulder_L/Elbow_L/Hand_L",   "root/pelvis/spine_01/spine_02/spine_03/clavicle_l/upperarm_l/lowerarm_l/hand_l") },
            { PolyBodyPart.Clavicle_R,                  List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_R",                             "root/pelvis/spine_01/spine_02/spine_03/clavicle_r") },
            { PolyBodyPart.Shoulder_R,                  List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_R/Shoulder_R",                  "root/pelvis/spine_01/spine_02/spine_03/clavicle_r/upperarm_r") },
            { PolyBodyPart.Elbow_R,                     List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_R/Shoulder_R/Elbow_R",          "root/pelvis/spine_01/spine_02/spine_03/clavicle_r/upperarm_r/lowerarm_r") },
            { PolyBodyPart.Hand_R,                      List("Root/Hips/Spine_01/Spine_02/Spine_03/Clavicle_R/Shoulder_R/Elbow_R/Hand_R",   "root/pelvis/spine_01/spine_02/spine_03/clavicle_r/upperarm_r/lowerarm_r/hand_r") },
            { PolyBodyPart.Neck,                        List("Root/Hips/Spine_01/Spine_02/Spine_03/Neck",                                   "root/pelvis/spine_01/spine_02/spine_03/neck_01") },
            { PolyBodyPart.Head,                        List("Root/Hips/Spine_01/Spine_02/Spine_03/Neck/Head",                              "root/pelvis/spine_01/spine_02/spine_03/neck_01/head") },
            { PolyBodyPart.UpperLeg_L,                  List("Root/Hips/UpperLeg_L",                                                        "root/pelvis/thigh_l") },
            { PolyBodyPart.LowerLeg_L,                  List("Root/Hips/UpperLeg_L/LowerLeg_L",                                             "root/pelvis/thigh_l/calf_l") },
            { PolyBodyPart.Ankle_L,                     List("Root/Hips/UpperLeg_L/LowerLeg_L/Ankle_L",                                     "root/pelvis/thigh_l/calf_l/foot_l") },
            { PolyBodyPart.Ball_L,                      List("Root/Hips/UpperLeg_L/LowerLeg_L/Ankle_L/Ball_L",                              "root/pelvis/thigh_l/calf_l/foot_l/ball_l") },
            { PolyBodyPart.Toes_L,                      List("Root/Hips/UpperLeg_L/LowerLeg_L/Ankle_L/Ball_L/Toes_L",                       "root/pelvis/thigh_l/calf_l/foot_l/ball_l/toes_l") },
            { PolyBodyPart.UpperLeg_R,                  List("Root/Hips/UpperLeg_R",                                                        "root/pelvis/thigh_r") },
            { PolyBodyPart.LowerLeg_R,                  List("Root/Hips/UpperLeg_R/LowerLeg_R",                                             "root/pelvis/thigh_r/calf_r") },
            { PolyBodyPart.Ankle_R,                     List("Root/Hips/UpperLeg_R/LowerLeg_R/Ankle_R",                                     "root/pelvis/thigh_r/calf_r/foot_r") },
            { PolyBodyPart.Ball_R,                      List("Root/Hips/UpperLeg_R/LowerLeg_R/Ankle_R/Ball_R",                              "root/pelvis/thigh_r/calf_r/foot_r/ball_r") },
            { PolyBodyPart.Toes_R,                      List("Root/Hips/UpperLeg_R/LowerLeg_R/Ankle_R/Ball_R/Toes_R",                       "root/pelvis/thigh_r/calf_r/foot_r/ball_r/toes_r") },
        };
        public static Dictionary<PolyPack, PolyDataPath> PathDic = new Dictionary<PolyPack, PolyDataPath>() {
            { PolyPack.PolygonAdventure,                PolyDataPath.Blds("Buildings").Chr("Characters").Env("Environments").Itm("Items").Prp("Props").Wep("Weapons") },
            { PolyPack.PolygonApocalypse,               PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters/Chr_Attach").Prp("DeadBodies", "Props").Env("Environment", "Generic").Fx("FX/Misc", "FX/Prefabbed").Itm("Item").Veh("Vehicles").Wep("Weapons/Guns", "Weapons/Melee", "Weapons/Misc", "Weapons/Modular", "Weapons/Vehicle_Weapons") },
            { PolyPack.PolygonBattleRoyale,             PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters/Attachments").Wep("Weapons") },
            { PolyPack.PolygonBossZombies,              PolyDataPath.Chrs("").ChrAtc("CharacterAttachments", "Props").Prp("Props").Wep("Props") },
            { PolyPack.PolygonCity,                     PolyDataPath.Blds("Buildings", "Buildings/Custom").Chr("Characters").Env("Environments", "Environments/Custom").Prp("Props").Veh("Vehicles") },
            { PolyPack.POLYGONCityCharacters,           PolyDataPath.Chrs("") },
            { PolyPack.PolygonConstruction,             PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters/Attachments").Env("Environments", "Generic").Itm("Items").Prp("Props", "Tools").Veh("Vehicles") },
            { PolyPack.PolygonDungeon,                  PolyDataPath.Chrs("Characters").Env("Environments/Bones", "Environments/Floors", "Environments/Misc", "Environments/Optimized", "Environments/Pillars", "Environments/Rocks", "Environments/Walls", "Environments/Wood").Fx("FX").Itm("Items").Prp("Props", "Props/Preset").Wep("Weapons") },
            { PolyPack.PolygonExplorers,                PolyDataPath.Chrs("Characters").ChrAtc("Characters/Attachments").Fx("FX").Prp("Props").Veh("Vehicle").Wep("Props") },
            { PolyPack.PolygonFantasyCharacters,        PolyDataPath.Chrs("").Wep("") },
            { PolyPack.PolygonFantasyHeroCharacters,    PolyDataPath.Chrs("Characters_Presets").ChrAtc("Characters_ModularParts_Static").Wep("Weapons") },
            { PolyPack.PolygonFantasyKingdom,           PolyDataPath.Chrs("Characters").ChrAtc("Characters/CharacterAttachments").Wep("Weapons") },
            { PolyPack.PolygonFantasyRivals,            PolyDataPath.Chrs("Characters").Fx("FX").Prp("Props").Wep("Weapons") },
            { PolyPack.PolygonFarm,                     PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters").Env("Environments", "Generic").Fx("FX").Prp("Plants", "Props").Veh("Vehicles").VehAtc("Vehicles") },
            { PolyPack.PolygonGangWarfare,              PolyDataPath.Blds("Buildings").Chr("Characters").Fx("FX").Env("Generic").Prp("Props").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonHeist,                    PolyDataPath.Pf("Prefab").Chr("Characters").ChrAtc("Masks").Env("Environment").Fx("FX").Itm("Items").Prp("Props").Veh("Vehicles").Wep("Weapons").WepAtc("Weapons") },
            { PolyPack.PolygonKnights,                  PolyDataPath.Blds("Buildings", "Buildings/Snow").Chr("Characters").Env("Environments", "Environments/Snow").Prp("Props", "Props/Snow").Wep("Weapons") },
            { PolyPack.PolygonMilitary,                 PolyDataPath.Blds("Buildings").Chr("Characters", "Characters/Alt_Soldiers").ChrAtc("Characters/Attachments", "Characters/Attachments/Patches").Env("Environment", "Generic").Fx("FX", "FX/Decals").Itm("Items").Prp("Props", "Props/Debris", "Props/Military", "Props/PipeLine", "Props/Rugs", "Props/Signs").Veh("Vehicles", "Vehicles/Destroyed").Wep("Weapons", "Weapons/Modular_Presets").WepAtc("Weapons/Modular/Attachments", "Weapons/Modular/Crosshairs", "Weapons/Modular/Scopes", "Weapons/Modular/Weapon_A", "Weapons/Modular/Weapon_B") },
            { PolyPack.PolygonOffice,                   PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters").Env("Generic").Prp("Props/Bathroom", "Props/Desk Props", "Props/Exterior", "Props/Furniture", "Props/Kitchen Props", "Props/Misc", "Props/Roof Props", "Props/Wall Props") },
            { PolyPack.PolygonPirates,                  PolyDataPath.Blds("Buildings").Chr("Characters").Env("Environments").Itm("Items").Prp("Props").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonPrototype,                PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters").Fx("FX").Env("Generic").Itm("Icons", "Other", "Primitives", "_NewAssets").Prp("Props").Veh("Vehicle") },
            { PolyPack.PolygonSamurai,                  PolyDataPath.Blds("Buildings").Chr("Characters").Env("Environments", "Snow").Fx("FX").Prp("Props").Wep("Weapons") },
            { PolyPack.PolygonSciFiCity,                PolyDataPath.Blds("Buildings").Chr("Characters").Env("Environments").Fx("FX").Itm("Icons").Prp("Props", "Signs").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonSciFiSpace,               PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters/Attachments", "Characters").Env("Environment").Fx("FX").Prp("Props", "Signs").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonSnow,                     PolyDataPath.Chrs("Characters").ChrAtc("Characters").Fx("FX").Prp("Props").Veh("Vehicle") },
            { PolyPack.PolygonSpy,                      PolyDataPath.Chrs("Characters").ChrAtc("Characters").Fx("FX").Prp("Prop").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonStarter,                  PolyDataPath.Envs("").Chr("Characters") },
            { PolyPack.PolygonTown,                     PolyDataPath.Blds("Buildings", "Buildings/Presets").Chr("Characters").Env("Environment", "Generic").Itm("Items").Prp("Props").Veh("Vehicles") },
            { PolyPack.PolygonVikings,                  PolyDataPath.Blds("Buildings").Chr("Characters").Env("Environments", "Snow_Variant").Fx("").Prp("Props").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonWar,                      PolyDataPath.Blds("Buildings").Chr("Characters").ChrAtc("Characters/Char_Attachments").Env("Environments").Fx("FX").Prp("Props").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonWestern,                  PolyDataPath.Blds("Buildings").Chr("Characters").Env("Environments").Fx("FX").Prp("Props").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonWesternFrontier,          PolyDataPath.Blds("Buildings").Chr("Characters").Env("Environments", "Generic").Fx("FX").Prp("Props").Veh("Vehicles").Wep("Weapons") },
            { PolyPack.PolygonZombies,                  PolyDataPath.Chrs("").Wep("") },
        };
        public static Dictionary<PolyChr, (int, string)> CapeDic = new Dictionary<PolyChr, (int, string)>() {
            { PolyChr.PolygonFantasyKingdom_SM_Chr_King_01, (1, "2,3,4,5,9,10,13,14,16,17,30,31,32,33,34,35,36,37,38,39,79,80,81,82,87,88,92,93,102,103,104,105,106,107,113,117,118,119,120") },
            { PolyChr.PolygonFantasyKingdom_SM_Chr_Mage_01, (2, "2,3,4,5,9,10,13,14,16,17,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,111,112,113,114,150,151,159,160") },
        };
        public static GameObject CrtChr(Transform parTf, RuntimeAnimatorController rac, PolyChr chr) {
            GameObject chrPf = null;
            PolyName pn = PolyName.Crt(chr);
            for (int i = 0; i < PathDic[pn.pack].chrs.Count; i++) {
                chrPf = A.LoadGo((pn.pack + "/" + PathDic[pn.pack].pf + "/" + PathDic[pn.pack].chrs[i] + "/" + pn.name).Replace("//", "/"));
                if (chrPf) {
                    GameObject chrGo = Ins(chrPf, parTf.position, parTf.rotation, parTf);
                    chrGo.An().runtimeAnimatorController = rac;
                    chrGo.Tls(V3.I);
                    if (PolyChrDic.ContainsKey(chr))
                        parTf.Tls(V3.V(PolyChrDic[chr].s));
                    if (CapeDic.ContainsKey(chr)) {
                        Cloth cloth = chrGo.PolySpine3().ChildGo(3, CapeDic[chr].Item1).Ac<Cloth>();
                        cloth.damping = 0.5f;
                        List<int> idxs = CapeDic[chr].Item2.IntList();
                        Transform clothParTf = cloth.Par();
                        CapsuleCollider capF = Crt.Pri(PrimitiveType.Capsule, Tf.NPRS("CapF", clothParTf.TfPnt(0, 0, 0.4f), clothParTf.Tr(), V3.V(1, 0.8f, 1)), C.I, clothParTf).Cc();
                        CapsuleCollider capU = Crt.Pri(PrimitiveType.Capsule, Tf.NPR("CapU", clothParTf.TfPnt(0, 0.6f, -0.6f), clothParTf.Tr() * Q.X(-90)), C.I, clothParTf).Cc();
                        capF.Hide();
                        capU.Hide();
                        cloth.capsuleColliders = new CapsuleCollider[] { capF, capU };
                        ClothSkinningCoefficient[] arr = new ClothSkinningCoefficient[cloth.coefficients.Length];
                        for (int j = 0; j < cloth.coefficients.Length; j++) {
                            arr[j].maxDistance = idxs.Contains(j) ? 0 : float.MaxValue;
                            arr[j].collisionSphereDistance = float.MaxValue;
                        }
                        cloth.coefficients = arr;
                    }
                    return chrGo;
                }
            }
            return null;
        }
    }
}